import { InMemoryCache } from "@apollo/client"
import ObjID from "./types/ObjID"

const cache = new InMemoryCache({
	typePolicies:{
		File:{
			fields:{
				id:{
					merge(_,incomming){
						// HACK: i use the merge function to change the id from a string to ObjID object.
						// afaik apollo does not yet support custom scalar types.
						if (!incomming){
							return incomming
						}else if (incomming instanceof ObjID){
							return incomming
						}else{
							return ObjID.fromString(incomming as string)
						}
					}
				}
			}
		},
		Directory:{
			fields:{
				id:{
					merge(_,incomming){
						if (!incomming){
							return incomming
						}else if (incomming instanceof ObjID){
							return incomming
						}else{
							return ObjID.fromString(incomming as string)
						}
					}
				}
			}
		},
		Query: {
			fields: {
				files: {
					merge(existing, incoming){
						return incoming
					}
				},
				directorys:{
					merge(existing, incoming){
						return incoming
					}
				}
			}
		}
	}
})

export default cache