import React from "react"
import { useEffect } from "react"
import genDownloadLink from "../functions/genDownloadLink"
import { FileOpenerProps } from "../types/FileOpenerProps"

const AudioOpener: React.FC<FileOpenerProps> = (props) => {
	const audio = React.createRef<HTMLAudioElement>()

	useEffect(()=>{
		if(audio.current){
			audio.current.volume = 0.1
		}
	},[audio])

	useEffect(()=>{
		if (!props.active && audio.current){
			audio.current.pause()
		}
	},[props.active])

	return (
		<div>
			<audio src={genDownloadLink(props.file.id)} controls ref={audio}></audio>
		</div>
	)
}

export default AudioOpener
