import React from "react"
import { useHistory } from "react-router-dom"
import { useListBucktesQuery } from "../generated/graphql"
import Breadcrum from "./Breadcrum"
import MoreMenu from "./MoreMenu"
import { ReactComponent as Spinner } from "./../assets/spinner.svg"
import Table, { Data } from "./Table"

const BucketSelect: React.FC = () => {
	const history = useHistory()
	const {data: buckets, loading} = useListBucktesQuery()
	const tableData: Data = {
		headers:[{name:"Bucket"}],
		body:(!buckets?[]:buckets.buckets.map(e=>{return {cells:[{name:e||""}],onClick:()=>{history.push(`/f/${e}`)}}}))
	}

	return (
		<div>
			<div className="flex justify-between h-12">
				<Breadcrum />
				<div className="ml-auto">
					<MoreMenu />
				</div>
			</div>
			<Table data={tableData}/>
			{loading && 
				<div className="flex justify-center mt-4">
					<Spinner className="animate-spin h-6 w-6 dark:text-white"  />
				</div>
			}
		</div>
	)
}

export default BucketSelect
