import React, { useRef } from "react"
import { useEffect } from "react"
import { useState } from "react"
import { MdCreateNewFolder } from "react-icons/md"

interface Props {
    onPressed?: (dirName: string)=>void
}

const CreateDirButton: React.FC<Props> = (props) => {
	const [name,setName] = useState("")
	const [show,setShow] = useState(false)
	const input = useRef<HTMLInputElement>(null)

	useEffect(()=>{
		if(show){
			input.current?.focus()
		}
	},[show])

	return (
		<div className="flex">
			<button
				onClick={()=>{
					setShow(!show)

				}}
			>
				<MdCreateNewFolder size="40"/>
			</button>
			<div className={`my-auto ${show?"w-44":"w-0"} overflow-hidden transition-all`} >
				<form 
					onSubmit={(e)=>{
						e.preventDefault()
						props.onPressed?.(name)
						setName("")
						setShow(false)
					}}>

					<input
						className="mx-1 text-input"
						type="text"
						onChange={(e)=>setName(e.target.value)}
						value={name}
						ref={input}
						onBlur={()=>{
							setShow(false)
							setName("")
						}}
					/>
				</form>
			</div>
		</div>
	)
}

export default CreateDirButton
