import React from "react"
import { useState } from "react"
import { MdMoreVert } from "react-icons/md"
import { useHistory } from "react-router-dom"
import { useOutsideClickRef } from "rooks"
import logout from "../functions/logout"
import MoreMenuEntry from "./MoreMenuEntry"

const MoreMenu: React.FC = () => {
	const [showMenu,setShowMenu] = useState(false)
	const history = useHistory()

	const [outsideRef] = useOutsideClickRef(()=>{
		setShowMenu(false)
	})

	return <>
		<button
			onClick={()=>{
				setShowMenu(!showMenu)
			}}
		>
			<MdMoreVert size="40"/>
		</button>
		<div className="" ref={outsideRef} >
			{
				showMenu && (
					<div className="absolute -ml-32 bg-white dark:bg-gray-800 p-2 border-2 dark:border-gray-900">
						{/* TODO: there has got to be a better way than "w-36" */}
						<div className="w-36">
							<ul>
								<MoreMenuEntry>
									Menu 1
								</MoreMenuEntry>
								<MoreMenuEntry>
									Menu 2
								</MoreMenuEntry>
								<MoreMenuEntry
									onclick={async ()=>{
										setShowMenu(false)
										await logout()
										history.push("/login")
									}}
								>
									Logout
								</MoreMenuEntry>
							</ul>
						</div>
					</div>
				)
			}
		</div>
	</>
}

export default MoreMenu
