import React from "react"
import { useEffect } from "react"
import { useRef } from "react"
import { useState } from "react"

interface Props {
    text: string
    edit: boolean
    onRename?: (newName: string)=>void
	onCancleRename?: ()=>void
}

const Renameable: React.FC<Props> = (props) => {
	const [inputValue,setinputValue] = useState(props.text)
	const inputRef = useRef<HTMLInputElement>(null)

	useEffect(()=>{
		if (props.edit){
			const i = inputValue.lastIndexOf(".")
			inputRef.current?.select()
			inputRef.current?.setSelectionRange(0,i == -1?inputValue.length:i)
		}else{
			setinputValue(props.text)
		}
	},[props.edit])

	return (
		<>
			{props.edit && <form className="inline" onSubmit={(e)=>{
				e.preventDefault()
				props.onRename?.(inputValue)
			}}>
				<input
					className="bg-transparent dark:text-gray-300 outline-none inline"
					type="text"
					ref={inputRef}
					value={inputValue}
					onClick={(e)=>e.stopPropagation()}
					onChange={(e)=>{setinputValue(e.target.value)}}
					onBlur={props.onCancleRename}
				/></form>
				
			}
			{!props.edit &&
                <div className="inline">{props.text}</div>
			}
		</>
	)
}

export default Renameable
